import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
import java.awt.Font;
import java.awt.Font;
import java.awt.GraphicsEnvironment;
import java.awt.Color;
import java.io.*;
/**
 * Write a description of class TextWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class TextWorld extends World
{
    private Menu myMenu;
    public int clicknum;
    public static String txt = ""; 
    /**
     * Constructor for objects of class TextWorld.
     * 
     */
    public TextWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 
        setUpMenu();
        prepare();
    }

    public void act()
    {
        listenToMenu();
    }

    public void setUpMenu()
    {
        ArrayList<String> menuStr = new ArrayList<String>(){{ add("Options"); }};
        myMenu = new Menu(menuStr);
        myMenu.addItems("Options/",  new ArrayList<String>(){{add("Load"); add("Save"); add("Delete All"); }});

        addObject(myMenu, 300, 350);
    }

    public void listenToMenu()
    {
        String s = myMenu.getItemPressed();
        if (s != null)
        {
            if (s.startsWith("Options"))
            {
                s = s.substring(s.indexOf("/") + 1);
                if (s.startsWith("Load"))
                {

                    {
                        if(TextMaker.txtString != null)
                            TextMaker.txtString = "";
                        
                        try{
                            // Open the file that is the first 
                            // command line parameter
                            FileInputStream fstream = new FileInputStream("File.txt");
                            // Get the object of DataInputStream
                            DataInputStream in = new DataInputStream(fstream);
                            BufferedReader br = new BufferedReader(new InputStreamReader(in));
                            String strLine;
                            //Read File Line By Line
                            while ((strLine = br.readLine()) != null)   {
                                // Print the content on the console

                                if(TextMaker.txtString == null)
                                {
                                    TextMaker.txtString = strLine + "\n";
                                    
                                }
                                else
                                {
                                    TextMaker.txtString += strLine + "\n";
                                    
                                }
                            }
                            if (TextMaker.txtString.length() > 1)  
                            {  
                                TextMaker.txtString = TextMaker.txtString.substring(0, TextMaker.txtString.length() - 1);  
                            } 
                            
                            
                            TextMaker.needimageset = true;
                            TextMaker.needlocationset = true;
                            //Close the input stream
                            in.close();

                        }
                        catch (Exception e){//Catch exception if any
                            System.err.println("Error: " + e.getMessage());
                        }
                    }
                }
                if(s.startsWith("Save"))
                {

                    try{
                        // Create file 
                        FileWriter fstream = new FileWriter("File.txt");
                        BufferedWriter out = new BufferedWriter(fstream);

                        String outTxt = TextMaker.txtString;
                        out.write((outTxt));  

                        //Close the output stream
                        out.close();
                    }
                    catch (Exception e){//Catch exception if any
                        System.err.println("Error: " + e.getMessage());

                    }
                }
                if(s.startsWith("Delete All")){
                    TextMaker.txtString = "";
                    TextMaker.needimageset = true;
                    TextMaker.setoriginalxy = true;
                }
            }
        }
    }

    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
        TextMaker textmaker = new TextMaker();
        addObject(textmaker, 300, 10);
    }
}
